<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class Sm00004006DocumentoContratoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getDocumentoContrato()
    {
        $sql = "SELECT LISTAGG(FCT_CONTRATODOCSITU.IDSITUACAOCONTRATO, ',') WITHIN GROUP(
                ORDER BY FCT_CONTRATODOCSITU.IDSITUACAOCONTRATO) AS IDSITUACAOCONTRATO,
                FCT_CONTRATODOC.NRSEQCONTDOC,
                FCT_CONTRATODOC.NRSEQCONTRATO,
                FCT_CONTRATO.IDSITUACAOCONTRATO AS IDSITUACAOATUALCONTRATO,
                FCT_CONTRATO.NRCONTRATOFCT||' - '||FCT_CONTRATO.DSREFERENCIACONT AS NMCONTRATO,
                FCT_CONTRATO.NRPARCNEGOCIO,
                PARCNEGOCIO.NMPRINCIPALPARC,
                TO_CHAR(NVL(FCT_CONTRATO.DTINIVIGENCONT, FCT_CONTRATO.DTINICIOCONTRATO), 'DD/MM/YYYY') AS DTINICONTRATO,
                TO_CHAR(NVL(FCT_CONTRATO.DTFINVIGENCONT, FCT_CONTRATO.DTFIMCONTRATO), 'DD/MM/YYYY') AS DTFINCONTRATO,
                FCT_MODELODOC.DSMODELODOCORCA,
                FCT_CONTRATODOC.NRSEQMODDOCFCT,
                FCT_CONTRATODOC.IDIDIOMA,
                FCT_CONTRATODOC.IDPADRAO,
                FCT_CONTRATODOC.NRORG,
                FCT_CONTRATODOC.NRORGINCLUSAO,
                FCT_CONTRATODOC.CDOPERINCLUSAO,
                OPINC.NMOPERADOR AS NMOPERINCLUSAO,
                FCT_CONTRATODOC.NRORGULTATU,
                FCT_CONTRATODOC.CDOPERULTATU,
                OPATU.NMOPERADOR AS NMOPERULTATU,
                FCT_CONTRATODOC.IDATIVO,
                FCT_CONTRATODOC.NMARQUIVO,
                FCT_CONTRATODOC.DSCAMINHOARQ,
                FCT_CONTRATODOC.DSTIPO,
                FCT_CONTRATODOC.VRTAMANHO,
                FCT_CONTRATODOC.VRTAMANHOLOGO
                FROM FCT_CONTRATODOC
                INNER JOIN FCT_CONTRATO ON FCT_CONTRATODOC.NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                AND FCT_CONTRATODOC.NRORG = FCT_CONTRATO.NRORG
                LEFT JOIN PARCNEGOCIO ON FCT_CONTRATO.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                AND FCT_CONTRATO.NRORG = PARCNEGOCIO.NRORG
                LEFT JOIN FCT_MODELODOC ON FCT_CONTRATODOC.NRSEQMODDOCFCT = FCT_MODELODOC.NRSEQMODDOCFCT
                AND FCT_CONTRATODOC.NRORG = FCT_MODELODOC.NRORG
                LEFT JOIN OPERADOR OPINC ON FCT_CONTRATODOC.CDOPERINCLUSAO = OPINC.CDOPERADOR
                AND FCT_CONTRATODOC.NRORG = OPINC.NRORG
                LEFT JOIN OPERADOR OPATU ON FCT_CONTRATODOC.CDOPERULTATU = OPATU.CDOPERADOR
                AND FCT_CONTRATODOC.NRORG = OPATU.NRORG
                LEFT JOIN FCT_CONTRATODOCSITU ON FCT_CONTRATODOC.NRSEQCONTDOC = FCT_CONTRATODOCSITU.NRSEQCONTDOC
                GROUP BY FCT_CONTRATODOC.NRSEQCONTDOC,
                FCT_CONTRATODOC.NRSEQCONTRATO,
                FCT_CONTRATO.IDSITUACAOCONTRATO,
                FCT_CONTRATO.NRCONTRATOFCT||' - '||FCT_CONTRATO.DSREFERENCIACONT,
                PARCNEGOCIO.NMPRINCIPALPARC,
                TO_CHAR(NVL(FCT_CONTRATO.DTINIVIGENCONT, FCT_CONTRATO.DTINICIOCONTRATO), 'DD/MM/YYYY'),
                TO_CHAR(NVL(FCT_CONTRATO.DTFINVIGENCONT, FCT_CONTRATO.DTFIMCONTRATO), 'DD/MM/YYYY'),
                FCT_MODELODOC.DSMODELODOCORCA,
                FCT_CONTRATODOC.IDIDIOMA,
                FCT_CONTRATODOC.IDPADRAO,
                FCT_CONTRATODOC.NRORG,
                FCT_CONTRATODOC.NRORGINCLUSAO,
                FCT_CONTRATODOC.CDOPERINCLUSAO,
                OPINC.NMOPERADOR,
                FCT_CONTRATODOC.NRORGULTATU,
                FCT_CONTRATODOC.CDOPERULTATU,
                OPATU.NMOPERADOR,
                FCT_CONTRATODOC.IDATIVO,
                FCT_CONTRATODOC.NMARQUIVO,
                FCT_CONTRATODOC.DSCAMINHOARQ,
                FCT_CONTRATODOC.DSTIPO,
                FCT_CONTRATODOC.VRTAMANHO,
                FCT_CONTRATODOC.VRTAMANHOLOGO,
                FCT_CONTRATODOC.NRSEQMODDOCFCT,
                FCT_CONTRATO.NRPARCNEGOCIO";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, [], [], null, null, null, array('IDSITUACAOCONTRATO'));
    }

    public function getTabAnexoDocumentoContrato(array $params)
    {
        $sql = "SELECT DOCIDIOMA.NRCONTRATODOCIDIOMA,
                DOCIDIOMA.NRSEQCONTDOC,
                DOCIDIOMA.CDIDIOM,
                IDIOMA.NMIDIOMA,
                IDIOMA.IDPADRAO,
                DECODE(IDIOMA.IDPADRAO, 'S', CONTRATODOC.NMARQUIVO, DOCIDIOMA.NMARQUIVO) AS NMARQUIVO,
                DECODE(IDIOMA.IDPADRAO, 'S', CONTRATODOC.DSCAMINHOARQ, DOCIDIOMA.DSCAMINHOARQ) AS DSCAMINHOARQ,
                DECODE(IDIOMA.IDPADRAO, 'S', CONTRATODOC.DSTIPO, DOCIDIOMA.DSTIPO) AS DSTIPO,
                DECODE(IDIOMA.IDPADRAO, 'S', CONTRATODOC.VRTAMANHO, DOCIDIOMA.VRTAMANHO) AS VRTAMANHO,
                DOCIDIOMA.IDATIVO,
                DOCIDIOMA.NRORG,
                DOCIDIOMA.DTINCLUSAO,
                DOCIDIOMA.NRORGINCLUSAO,
                DOCIDIOMA.CDOPERINCLUSAO,
                DOCIDIOMA.DTULTATU,
                DOCIDIOMA.NRORGULTATU,
                DOCIDIOMA.CDOPERULTATU
                FROM FCT_CONTRATODOCIDIOMA DOCIDIOMA
                INNER JOIN IDIOMA ON DOCIDIOMA.CDIDIOM = IDIOMA.CDIDIOM
                INNER JOIN FCT_CONTRATODOC CONTRATODOC ON DOCIDIOMA.NRSEQCONTDOC = CONTRATODOC.NRSEQCONTDOC
                WHERE DOCIDIOMA.NRSEQCONTDOC = :NRSEQCONTDOC
        UNION ALL
                SELECT NULL AS NRCONTRATODOCIDIOMA,
                        CONTRATODOC.NRSEQCONTDOC,
                        IDIOMA.CDIDIOM,
                        IDIOMA.NMIDIOMA,
                        IDIOMA.IDPADRAO,
                        CONTRATODOC.NMARQUIVO,
                        CONTRATODOC.DSCAMINHOARQ,
                        CONTRATODOC.DSTIPO,
                        CONTRATODOC.VRTAMANHO,
                        CONTRATODOC.IDATIVO,
                        CONTRATODOC.NRORG,
                        CONTRATODOC.DTINCLUSAO,
                        CONTRATODOC.NRORGINCLUSAO,
                        CONTRATODOC.CDOPERINCLUSAO,
                        CONTRATODOC.DTULTATU,
                        CONTRATODOC.NRORGULTATU,
                        CONTRATODOC.CDOPERULTATU
                        FROM FCT_CONTRATODOC CONTRATODOC
                        JOIN IDIOMA ON IDIOMA.IDPADRAO = 'S'
                        WHERE NOT EXISTS (SELECT 1
                                            FROM FCT_CONTRATODOCIDIOMA
                                            JOIN IDIOMA
                                            ON FCT_CONTRATODOCIDIOMA.CDIDIOM = IDIOMA.CDIDIOM
                                            WHERE NRSEQCONTDOC = CONTRATODOC.NRSEQCONTDOC
                                            AND IDIOMA.IDPADRAO = 'S')
                            AND NRSEQCONTDOC = :NRSEQCONTDOC
                            AND CONTRATODOC.NMARQUIVO IS NOT NULL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getContratosDocumento($parametro)
    {
        $sql = "SELECT FCT_CONTRATO.NRSEQCONTRATO,
                FCT_CONTRATO.NRCONTRATOFCT||' - '||FCT_CONTRATO.DSREFERENCIACONT AS NMCONTRATO,
                TO_CHAR(NVL(FCT_CONTRATO.DTINIVIGENCONT, FCT_CONTRATO.DTINICIOCONTRATO), 'DD/MM/YYYY') AS DTINICONTRATO,
                TO_CHAR(NVL(FCT_CONTRATO.DTFINVIGENCONT, FCT_CONTRATO.DTFIMCONTRATO), 'DD/MM/YYYY') AS DTFINCONTRATO,
                PARCNEGOCIO.NMPRINCIPALPARC, 
                FCT_CONTRATO.IDSITUACAOCONTRATO AS IDSITUACAOATUALCONTRATO
                FROM FCT_CONTRATO
                INNER JOIN FCT_CONTRATODOC ON FCT_CONTRATO.NRSEQCONTRATO = FCT_CONTRATODOC.NRSEQCONTRATO
                AND FCT_CONTRATO.NRORG = FCT_CONTRATODOC.NRORG
                LEFT JOIN PARCNEGOCIO ON FCT_CONTRATO.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametro);
    }

    public function inserirDocumentoContrato(array $params)
    {
        $sql = "INSERT INTO FCT_CONTRATODOC (
            NRSEQCONTDOC,       NRSEQCONTRATO,      IDPADRAO,
            VRTAMANHOLOGO,      IDATIVO,            DTINCLUSAO,   
            CDOPERINCLUSAO,     NRORG,              NRORGINCLUSAO,
            NRSEQMODDOCFCT
        )
        VALUES (
            :NRSEQCONTDOC,      :NRSEQCONTRATO,     :IDPADRAO,
            :VRTAMANHOLOGO,     :IDATIVO,           SYSDATE,    
            :CDOPERINCLUSAO,    :NRORG,             :NRORG,
            :NRSEQMODDOCFCT
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function inserirSituacaoDocumentoContrato(array $params)
    {
        $sql = "INSERT INTO FCT_CONTRATODOCSITU (
                    NRCONTRATODOCSITU,  IDSITUACAOCONTRATO,  NRSEQCONTDOC,  
                    IDATIVO,            NRORG,               DTINCLUSAO,         
                    NRORGINCLUSAO,      CDOPERINCLUSAO         
                    )
                VALUES (
                    :NRCONTRATODOCSITU, :IDSITUACAOCONTRATO, :NRSEQCONTDOC,
                    :IDATIVO,           :NRORG,               SYSDATE,            
                    :NRORGINCLUSAO,     :CDOPERINCLUSAO      
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateDocumentoContrato($params)
    {
        $sql = "UPDATE FCT_CONTRATODOC 
        SET IDPADRAO = :IDPADRAO, 
        VRTAMANHOLOGO = :VRTAMANHOLOGO,
        CDOPERULTATU = :CDOPERULTATU
        WHERE NRSEQCONTDOC = :NRSEQCONTDOC";
        $this->connection->executeStatement($sql, $params);
    }

    public function deleteDocumentoContrato($params)
    {
        $sql = "DELETE FROM FCT_CONTRATODOC WHERE NRSEQCONTDOC = :NRSEQCONTDOC";
        $this->connection->executeStatement($sql, $params);
    }

    public function getDocumentoAnt(array $params)
    {
        $sql = "SELECT NMARQUIVO,
                  VRTAMANHO,
                  DSCAMINHOARQ,
                  DSTIPO
                FROM FCT_CONTRATODOC
                WHERE NRSEQCONTDOC = :NRSEQCONTDOC";
        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function validaDocIdioma($params)
    {

        $sql = "SELECT COUNT (*) AS QTD 
                FROM FCT_CONTRATODOCIDIOMA
                WHERE NRSEQCONTDOC  = :NRSEQCONTDOC
                AND CDIDIOM           = :CDIDIOM
                AND NRCONTRATODOCIDIOMA <> NVL(:NRCONTRATODOCIDIOMA, -1)";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function atualizarModeloDocumentoContrato($parametros)
    {
        $sql = "UPDATE FCT_CONTRATODOC
                SET     NMARQUIVO = :NMARQUIVO,
                        DSCAMINHOARQ = :DSCAMINHOARQ,
                        DSTIPO = :DSTIPO,
                        VRTAMANHO = :VRTAMANHO,
                        CDOPERULTATU = :CDOPERULTATU,
                        NRORGULTATU = :NRORGULTATU,
                        DTULTATU = SYSDATE
                WHERE NRSEQCONTDOC = :NRSEQCONTDOC";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirModeloDocumentoContrato($parametros)
    {
        $sql = "INSERT INTO FCT_CONTRATODOCIDIOMA (
                    NRCONTRATODOCIDIOMA,    NRSEQCONTDOC,           CDIDIOM,
                    IDATIVO,                NMARQUIVO,              DSCAMINHOARQ,           
                    DSTIPO,                 VRTAMANHO,              NRORG,                  
                    NRORGINCLUSAO,          CDOPERINCLUSAO,         DTINCLUSAO           
                    )
                    VALUES(
                    :NRCONTRATODOCIDIOMA,   :NRSEQCONTDOC,          :CDIDIOM,
                    :IDATIVO,               :NMARQUIVO,             :DSCAMINHOARQ,          
                    :DSTIPO,                :VRTAMANHO,             :NRORG,                 
                    :NRORGINCLUSAO,         :CDOPERINCLUSAO,        SYSDATE
                    )";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirModeloDocumento($params)
    {
        $sql = "INSERT INTO FCT_MODELODOC (
                    NRSEQMODDOCFCT,         DSMODELODOCORCA,          IDATIVO,
                    DTINCLUSAO
                    )
                    VALUES
                    (
                    :NRSEQMODDOCFCT,        :DSMODELODOCORCA,        :IDATIVO,
                    SYSDATE
                    )";

        $this->connection->executeStatement($sql, $params);
    }

    public function limparAnexoModeloDocContrato(array $parametros)
    {
        $sql = "UPDATE FCT_CONTRATODOC
                   SET NMARQUIVO = NULL,
                       DSCAMINHOARQ = NULL,
                       DSTIPO = NULL,
                       VRTAMANHO = NULL
                 WHERE NRSEQCONTDOC = :NRSEQCONTDOC";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateModeloDocumentoContrato($parametros)
    {
        $sql = "UPDATE FCT_CONTRATODOCIDIOMA
                SET NRSEQCONTDOC = :NRSEQCONTDOC,
                        CDIDIOM     = :CDIDIOM,
                        IDATIVO = :IDATIVO,
                        NMARQUIVO = :NMARQUIVO,
                        DSCAMINHOARQ = :DSCAMINHOARQ,
                        DSTIPO = :DSTIPO,
                        VRTAMANHO = :VRTAMANHO,
                        CDOPERULTATU = :CDOPERULTATU,
                        NRORGULTATU = :NRORGULTATU,
                        DTULTATU = SYSDATE
                WHERE NRCONTRATODOCIDIOMA = :NRCONTRATODOCIDIOMA";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function getDocumento(array $params)
    {
        $sql = "SELECT NMARQUIVO,
                  VRTAMANHO,
                  DSCAMINHOARQ,
                  DSTIPO
                FROM FCT_CONTRATODOCIDIOMA
                WHERE NRCONTRATODOCIDIOMA = :NRCONTRATODOCIDIOMA";
        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function limparAnexoModeloDocumentoContrato(array $params)
    {
        $sql = "UPDATE FCT_CONTRATODOCIDIOMA
                   SET DSCAMINHOARQ = NULL,
                       NMARQUIVO    = NULL,
                       VRTAMANHO    = NULL,
                       DSTIPO       = NULL
                 WHERE NRCONTRATODOCIDIOMA = :NRCONTRATODOCIDIOMA";
        $this->connection->executeStatement($sql, $params);
    }

    public function deletarAnexoDocumentoContrato($params)
    {
        $sql = "DELETE FROM FCT_CONTRATODOCIDIOMA
                WHERE NRCONTRATODOCIDIOMA = :NRCONTRATODOCIDIOMA";
        $this->connection->executeStatement($sql, $params);
    }

    public function getDocumentoContratoIdioma(array $params)
    {
        $sql = "SELECT DOCID.NRSEQCONTDOC,
                       CTDOC.NRSEQMODDOCFCT,
                       DOCID.NMARQUIVO,
                       DOCID.DSCAMINHOARQ,
                       DOCID.DSTIPO,
                       DOCID.VRTAMANHO,
                       DOCID.CDIDIOM
                  FROM FCT_CONTRATODOCIDIOMA DOCID
                  JOIN FCT_CONTRATODOC CTDOC
                    ON DOCID.NRSEQCONTDOC = CTDOC.NRSEQCONTDOC
                 WHERE DOCID.NRCONTRATODOCIDIOMA = :NRCONTRATODOCIDIOMA
                   AND DOCID.NRORG                = :NRORG";
        
        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function getModeloDocumentoIdioma(array $params)
    {
        $sql = "SELECT NMARQUIVO,
                       DSCAMINHOARQ,
                       DSTIPO,
                       VRTAMANHO
                  FROM FCT_MODELODOCIDIOMA
                 WHERE NRSEQMODDOCFCT = :NRSEQMODDOCFCT
                   AND CDIDIOM        = :CDIDIOM";
        
        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function atualizarDocumentoContratoIdioma(array $params)
    {
        $sql = "UPDATE FCT_CONTRATODOCIDIOMA
                   SET NMARQUIVO     = :NMARQUIVO,
                       DSCAMINHOARQ  = :DSCAMINHOARQ,
                       DSTIPO        = :DSTIPO,
                       VRTAMANHO     = :VRTAMANHO,
                       CDOPERULTATU  = :CDOPERULTATU,
                       DTULTATU      = SYSDATE
                 WHERE NRCONTRATODOCIDIOMA = :NRCONTRATODOCIDIOMA
                   AND NRORG                = :NRORG";
        
        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarAnexoDocumentoContrato(array $params)
    {
        $sql = "UPDATE FCT_CONTRATODOC
                   SET NMARQUIVO    = :NMARQUIVO,
                       VRTAMANHO    = :VRTAMANHO,
                       DSTIPO       = :DSTIPO,
                       DSCAMINHOARQ = :DSCAMINHOARQ
                 WHERE NRSEQCONTDOC = :NRSEQCONTDOC";

        $this->connection->executeStatement($sql, $params);
    }

    public function getAnexoContrato(array $params)
    {
        $sql = "SELECT CTDOC.NRSEQCONTDOC,
                        CTDOC.NRSEQMODDOCFCT,
                        CTDOC.NMARQUIVO,
                        CTDOC.DSCAMINHOARQ,
                        CTDOC.DSTIPO,
                        CTDOC.VRTAMANHO
                FROM FCT_CONTRATODOC CTDOC
                WHERE CTDOC.NRSEQCONTDOC = :NRSEQCONTDOC";
        
        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function getParceiroNegocioContrato()
    {
        $sql = "SELECT PARCNEGOCIO.NRPARCNEGOCIO,
                PARCNEGOCIO.NMPRINCIPALPARC
                FROM FCT_CONTRATO
                LEFT JOIN PARCNEGOCIO ON FCT_CONTRATO.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO";
         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getNomeContrato()
    {
        $sql = "SELECT FCT_CONTRATO.NRCONTRATOFCT||' - '||FCT_CONTRATO.DSREFERENCIACONT AS NMCONTRATO,
                FCT_CONTRATODOC.NRSEQCONTRATO
                FROM FCT_CONTRATODOC
                INNER JOIN FCT_CONTRATO ON FCT_CONTRATODOC.NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO";
         return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
