<?php
namespace SM\Service;

use SM\Factory\MapaFaturamentoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\FindService;

class MapaFaturamentoService
{

    protected $MapaFaturamentoFactory;
    protected $Environment;
    protected $newCode;
    protected $FindService;

    public function __construct(MapaFaturamentoFactory $MapaFaturamentoFactory, Environment $Environment, NewCode $newCode, FindService $FindService)
    {
        $this->MapaFaturamentoFactory       = $MapaFaturamentoFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->FindService                  = $FindService;
    }

    public function getMapaFaturamento($parametros)
    {
        $filtro = '';
        if (!isset($parametros['dynamic_filter'])) {
            $dsarvoresup = ($parametros['DSARVORESUP'] === 'NULL') ? $parametros['DSARVORESUP'] : "'".$parametros['DSARVORESUP']."'";
            $filtro = ' WHERE (((DSARVORESUP IS NULL) AND ('.$dsarvoresup.' IS NULL)) OR (DSARVORESUP = '.$dsarvoresup.'))';
            return $this->MapaFaturamentoFactory->getMapaFaturamento($filtro);
        } else {
            $data = $this->MapaFaturamentoFactory->getMapaFaturamento($filtro);
            unset($parametros['dynamic_filter']);

            $filhos = array();
            foreach ($data['data'] as $value) {
                array_push($filhos, $value['DSARVORE']);
            }

            if (count($filhos) > 0) {
                $filtro = 'CONNECT BY PRIOR DSARVORESUP = DSARVORE START WITH DSARVORE  IN('.$this->FindService->formatarArray($filhos).')';
                return $this->MapaFaturamentoFactory->getMapaFaturamento2($filtro);
            }
        }
    }
}
